<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Gestion de Registros pendientes:
    </q-toolbar>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="paginadoGenericoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading :showing="loading" />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="paginadoGenericoStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <q-list dense>
              <q-item>
                <q-item-section>Documento</q-item-section>
                <q-item-section side> {{ props.row.documento }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Nombre</q-item-section>
                <q-item-section side>
                  {{ props.row.nombre }} ,{{ props.row.apellido }}
                </q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Nacimiento</q-item-section>
                <q-item-section side>
                  {{ props.row.f_nacimiento }}</q-item-section
                >
              </q-item>
              <q-item>
                <q-item-section>Celular</q-item-section>
                <q-item-section side> {{ props.row.celular }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Email</q-item-section>
                <q-item-section side> {{ props.row.email }}</q-item-section>
              </q-item>
            </q-list>
          </q-td>
        </template>

        <template v-slot:body-cell-organismo="props">
          <q-td :props="props">
            <q-list dense>
              <q-item>
                <q-item-section>Grupo</q-item-section>
                <q-item-section side> {{ props.row.grupo }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Organismo</q-item-section>
                <q-item-section side> {{ props.row.organismo }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Zona</q-item-section>
                <q-item-section side> {{ props.row.zona }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section>Distrito</q-item-section>
                <q-item-section side> {{ props.row.distrito }}</q-item-section>
              </q-item>
            </q-list>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <div class="q-gutter-sm">
              <q-btn
                square
                size="sm"
                color="green"
                icon="person_search"
                label="Aceptar"
                :to="'/membresia/personas/perfil/' + props.row.uuid"
              >
              </q-btn>
              <q-btn
                square
                size="sm"
                color="red"
                icon="person_search"
                label="Rechazar"
                :to="'/membresia/personas/perfil/' + props.row.uuid"
              >
              </q-btn>
            </div>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { usePaginadoGenericoStore } from 'src/stores/paginado-generico';
import Loading from 'src/components/Loading.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'organismo', label: 'organismo', field: 'organismo', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const paginadoGenericoStore = usePaginadoGenericoStore();

    onMounted(() => {
      paginadoGenericoStore.$reset();
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      paginadoGenericoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      paginadoGenericoStore.filtroActivado = true;
      paginadoGenericoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/administrador/registro_pendiente', {
          params: paginadoGenericoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          paginadoGenericoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      paginadoGenericoStore.resetFiltros();
      onRequest();
    }

    function borrarFuncion(uuid: string) {
      api.delete('/api/persona/funcion/', { data: { uuid } });
      onRequest();
    }

    return {
      columnas,
      dataSet,
      paginadoGenericoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
      borrarFuncion,
    };
  },
});
</script>
